# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import sys
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
if sys.version_info >= (3, 11):
    from typing import NotRequired, TypedDict, TypeAlias
else:
    from typing_extensions import NotRequired, TypedDict, TypeAlias
from . import _utilities
from . import outputs
from ._inputs import *

__all__ = [
    'GetDestinationResult',
    'AwaitableGetDestinationResult',
    'get_destination',
    'get_destination_output',
]

@pulumi.output_type
class GetDestinationResult:
    """
    A collection of values returned by getDestination.
    """
    def __init__(__self__, config=None, daylight_saving_time_enabled=None, group_id=None, hybrid_deployment_agent_id=None, id=None, local_processing_agent_id=None, networking_method=None, private_link_id=None, region=None, service=None, setup_status=None, time_zone_offset=None):
        if config and not isinstance(config, dict):
            raise TypeError("Expected argument 'config' to be a dict")
        pulumi.set(__self__, "config", config)
        if daylight_saving_time_enabled and not isinstance(daylight_saving_time_enabled, bool):
            raise TypeError("Expected argument 'daylight_saving_time_enabled' to be a bool")
        pulumi.set(__self__, "daylight_saving_time_enabled", daylight_saving_time_enabled)
        if group_id and not isinstance(group_id, str):
            raise TypeError("Expected argument 'group_id' to be a str")
        pulumi.set(__self__, "group_id", group_id)
        if hybrid_deployment_agent_id and not isinstance(hybrid_deployment_agent_id, str):
            raise TypeError("Expected argument 'hybrid_deployment_agent_id' to be a str")
        pulumi.set(__self__, "hybrid_deployment_agent_id", hybrid_deployment_agent_id)
        if id and not isinstance(id, str):
            raise TypeError("Expected argument 'id' to be a str")
        pulumi.set(__self__, "id", id)
        if local_processing_agent_id and not isinstance(local_processing_agent_id, str):
            raise TypeError("Expected argument 'local_processing_agent_id' to be a str")
        pulumi.set(__self__, "local_processing_agent_id", local_processing_agent_id)
        if networking_method and not isinstance(networking_method, str):
            raise TypeError("Expected argument 'networking_method' to be a str")
        pulumi.set(__self__, "networking_method", networking_method)
        if private_link_id and not isinstance(private_link_id, str):
            raise TypeError("Expected argument 'private_link_id' to be a str")
        pulumi.set(__self__, "private_link_id", private_link_id)
        if region and not isinstance(region, str):
            raise TypeError("Expected argument 'region' to be a str")
        pulumi.set(__self__, "region", region)
        if service and not isinstance(service, str):
            raise TypeError("Expected argument 'service' to be a str")
        pulumi.set(__self__, "service", service)
        if setup_status and not isinstance(setup_status, str):
            raise TypeError("Expected argument 'setup_status' to be a str")
        pulumi.set(__self__, "setup_status", setup_status)
        if time_zone_offset and not isinstance(time_zone_offset, str):
            raise TypeError("Expected argument 'time_zone_offset' to be a str")
        pulumi.set(__self__, "time_zone_offset", time_zone_offset)

    @property
    @pulumi.getter
    def config(self) -> Optional['outputs.GetDestinationConfigResult']:
        return pulumi.get(self, "config")

    @property
    @pulumi.getter(name="daylightSavingTimeEnabled")
    def daylight_saving_time_enabled(self) -> bool:
        return pulumi.get(self, "daylight_saving_time_enabled")

    @property
    @pulumi.getter(name="groupId")
    def group_id(self) -> str:
        return pulumi.get(self, "group_id")

    @property
    @pulumi.getter(name="hybridDeploymentAgentId")
    def hybrid_deployment_agent_id(self) -> str:
        return pulumi.get(self, "hybrid_deployment_agent_id")

    @property
    @pulumi.getter
    def id(self) -> str:
        return pulumi.get(self, "id")

    @property
    @pulumi.getter(name="localProcessingAgentId")
    def local_processing_agent_id(self) -> str:
        return pulumi.get(self, "local_processing_agent_id")

    @property
    @pulumi.getter(name="networkingMethod")
    def networking_method(self) -> str:
        return pulumi.get(self, "networking_method")

    @property
    @pulumi.getter(name="privateLinkId")
    def private_link_id(self) -> str:
        return pulumi.get(self, "private_link_id")

    @property
    @pulumi.getter
    def region(self) -> str:
        return pulumi.get(self, "region")

    @property
    @pulumi.getter
    def service(self) -> str:
        return pulumi.get(self, "service")

    @property
    @pulumi.getter(name="setupStatus")
    def setup_status(self) -> str:
        return pulumi.get(self, "setup_status")

    @property
    @pulumi.getter(name="timeZoneOffset")
    def time_zone_offset(self) -> str:
        return pulumi.get(self, "time_zone_offset")


class AwaitableGetDestinationResult(GetDestinationResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetDestinationResult(
            config=self.config,
            daylight_saving_time_enabled=self.daylight_saving_time_enabled,
            group_id=self.group_id,
            hybrid_deployment_agent_id=self.hybrid_deployment_agent_id,
            id=self.id,
            local_processing_agent_id=self.local_processing_agent_id,
            networking_method=self.networking_method,
            private_link_id=self.private_link_id,
            region=self.region,
            service=self.service,
            setup_status=self.setup_status,
            time_zone_offset=self.time_zone_offset)


def get_destination(config: Optional[Union['GetDestinationConfigArgs', 'GetDestinationConfigArgsDict']] = None,
                    id: Optional[str] = None,
                    opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetDestinationResult:
    """
    This data source returns a destination object.

    ## Example Usage

    ```python
    import pulumi
    import pulumi_fivetran as fivetran

    dest = fivetran.get_destination(id="anonymous_mystery")
    ```
    """
    __args__ = dict()
    __args__['config'] = config
    __args__['id'] = id
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('fivetran:index/getDestination:getDestination', __args__, opts=opts, typ=GetDestinationResult).value

    return AwaitableGetDestinationResult(
        config=pulumi.get(__ret__, 'config'),
        daylight_saving_time_enabled=pulumi.get(__ret__, 'daylight_saving_time_enabled'),
        group_id=pulumi.get(__ret__, 'group_id'),
        hybrid_deployment_agent_id=pulumi.get(__ret__, 'hybrid_deployment_agent_id'),
        id=pulumi.get(__ret__, 'id'),
        local_processing_agent_id=pulumi.get(__ret__, 'local_processing_agent_id'),
        networking_method=pulumi.get(__ret__, 'networking_method'),
        private_link_id=pulumi.get(__ret__, 'private_link_id'),
        region=pulumi.get(__ret__, 'region'),
        service=pulumi.get(__ret__, 'service'),
        setup_status=pulumi.get(__ret__, 'setup_status'),
        time_zone_offset=pulumi.get(__ret__, 'time_zone_offset'))
def get_destination_output(config: Optional[pulumi.Input[Optional[Union['GetDestinationConfigArgs', 'GetDestinationConfigArgsDict']]]] = None,
                           id: Optional[pulumi.Input[str]] = None,
                           opts: Optional[pulumi.InvokeOptions] = None) -> pulumi.Output[GetDestinationResult]:
    """
    This data source returns a destination object.

    ## Example Usage

    ```python
    import pulumi
    import pulumi_fivetran as fivetran

    dest = fivetran.get_destination(id="anonymous_mystery")
    ```
    """
    __args__ = dict()
    __args__['config'] = config
    __args__['id'] = id
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke_output('fivetran:index/getDestination:getDestination', __args__, opts=opts, typ=GetDestinationResult)
    return __ret__.apply(lambda __response__: GetDestinationResult(
        config=pulumi.get(__response__, 'config'),
        daylight_saving_time_enabled=pulumi.get(__response__, 'daylight_saving_time_enabled'),
        group_id=pulumi.get(__response__, 'group_id'),
        hybrid_deployment_agent_id=pulumi.get(__response__, 'hybrid_deployment_agent_id'),
        id=pulumi.get(__response__, 'id'),
        local_processing_agent_id=pulumi.get(__response__, 'local_processing_agent_id'),
        networking_method=pulumi.get(__response__, 'networking_method'),
        private_link_id=pulumi.get(__response__, 'private_link_id'),
        region=pulumi.get(__response__, 'region'),
        service=pulumi.get(__response__, 'service'),
        setup_status=pulumi.get(__response__, 'setup_status'),
        time_zone_offset=pulumi.get(__response__, 'time_zone_offset')))
