# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import sys
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
if sys.version_info >= (3, 11):
    from typing import NotRequired, TypedDict, TypeAlias
else:
    from typing_extensions import NotRequired, TypedDict, TypeAlias
from . import _utilities
from . import outputs
from ._inputs import *

__all__ = [
    'GetProxyAgentsResult',
    'AwaitableGetProxyAgentsResult',
    'get_proxy_agents',
    'get_proxy_agents_output',
]

@pulumi.output_type
class GetProxyAgentsResult:
    """
    A collection of values returned by getProxyAgents.
    """
    def __init__(__self__, id=None, items=None):
        if id and not isinstance(id, str):
            raise TypeError("Expected argument 'id' to be a str")
        pulumi.set(__self__, "id", id)
        if items and not isinstance(items, list):
            raise TypeError("Expected argument 'items' to be a list")
        pulumi.set(__self__, "items", items)

    @property
    @pulumi.getter
    def id(self) -> str:
        """
        The provider-assigned unique ID for this managed resource.
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter
    def items(self) -> Optional[Sequence['outputs.GetProxyAgentsItemResult']]:
        return pulumi.get(self, "items")


class AwaitableGetProxyAgentsResult(GetProxyAgentsResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetProxyAgentsResult(
            id=self.id,
            items=self.items)


def get_proxy_agents(items: Optional[Sequence[Union['GetProxyAgentsItemArgs', 'GetProxyAgentsItemArgsDict']]] = None,
                     opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetProxyAgentsResult:
    """
    This data source returns a list of all proxy agents within your Fivetran account.

    ## Example Usage

    ```python
    import pulumi
    import pulumi_fivetran as fivetran

    proxy_agents = fivetran.get_proxy_agents()
    ```
    """
    __args__ = dict()
    __args__['items'] = items
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('fivetran:index/getProxyAgents:getProxyAgents', __args__, opts=opts, typ=GetProxyAgentsResult).value

    return AwaitableGetProxyAgentsResult(
        id=pulumi.get(__ret__, 'id'),
        items=pulumi.get(__ret__, 'items'))
def get_proxy_agents_output(items: Optional[pulumi.Input[Optional[Sequence[Union['GetProxyAgentsItemArgs', 'GetProxyAgentsItemArgsDict']]]]] = None,
                            opts: Optional[pulumi.InvokeOptions] = None) -> pulumi.Output[GetProxyAgentsResult]:
    """
    This data source returns a list of all proxy agents within your Fivetran account.

    ## Example Usage

    ```python
    import pulumi
    import pulumi_fivetran as fivetran

    proxy_agents = fivetran.get_proxy_agents()
    ```
    """
    __args__ = dict()
    __args__['items'] = items
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke_output('fivetran:index/getProxyAgents:getProxyAgents', __args__, opts=opts, typ=GetProxyAgentsResult)
    return __ret__.apply(lambda __response__: GetProxyAgentsResult(
        id=pulumi.get(__response__, 'id'),
        items=pulumi.get(__response__, 'items')))
